PROGRAM legendre_polynome
  IMPLICIT NONE
  DOUBLE PRECISION x
  DOUBLE PRECISION P
  INTEGER l, m
  DOUBLE PRECISION theta
  INTEGER i
  DOUBLE PRECISION pi
  INTEGER dfact
  PARAMETER (pi = 2d0*ACOS(0d0))
  WRITE(*,*) "theta P00 P10 P11 P20 P21 P22 P30 P31 P32 P33 P40 P41 P42 P43 P44"
  do i = 0, 100 - 1, 1
    theta = DBLE(i)*2d0*pi/100d0
    x = COS(theta)
    WRITE(*, "(100g15.5)", ADVANCE="NO") theta !advance bewirkt, dass write keinen automatischen zeilenumbruch macht
    do l = 0, 4, 1
      do m = 0, l, 1
        WRITE(*, "(100g15.5)", ADVANCE="NO") P(l,m,x)
      end do
    end do
    WRITE(*,*) ""
    ! negativer Zweig (wenn in P eine Wurzel vorkommt, wird nur der positive Zweig durch P berücksichtigt; wenn l-m ungerade):
    WRITE(*, "(100g15.5)", ADVANCE="NO") theta
    do l = 0, 4, 1
      do m = 0, l, 1
        IF ((mod((l - m), 2)) .NE. 0) THEN
          WRITE(*, "(100g15.5)", ADVANCE="NO") (-P(l,m,x))
        ELSE
          WRITE(*, "(100g15.5)", ADVANCE="NO") P(l,m,x)
        END IF
      end do
    end do
    WRITE(*,*) ""
    
  end do
END

RECURSIVE DOUBLE PRECISION FUNCTION P(l,m,x) RESULT (R) ! rekursive Funktion zur Berechnung der zugeordneten Legendre Polynome
  implicit none
  INTEGER dfact
  INTEGER l, m, temp, lminus1, lminus2
  DOUBLE PRECISION x
  if (m > (l + 1)) then
    WRITE(*,*) "Eingabe ungueltig (m > l+1)!"
    STOP
  else if (m == l + 1) then
    R = 0
  else if (l == m) then
    temp = 2*l - 1
    R = dfact(temp)*((1d0 - x*x)**(l/2d0))
  else 
    lminus1 = l - 1
    lminus2 = l - 2
    R = ((2*l - 1)*x*P(lminus1,m,x) - (l + m - 1)*P(lminus2,m,x))/DBLE(l - m)
  end if
END

INTEGER FUNCTION dfact(n) !Doppelfakultät
  implicit none
  integer n
  integer i
  dfact = 1
  do i=n, 1, -2
     dfact = dfact*i
  end do
END

