RECURSIVE DOUBLE PRECISION FUNCTION P(l,m,x) RESULT (R) ! rekursive Funktion zur Berechnung der zugeordneten Legendre Polynome
  implicit none
  INTEGER dfact
  INTEGER l, m, temp, lminus1, lminus2
  DOUBLE PRECISION x
  if (m > (l + 1)) then
    WRITE(*,*) "Eingabe ungueltig (m > l+1)!"
    STOP
  else if (m == l + 1) then
    R = 0
  else if (l == m) then
    temp = 2*l - 1
    R = dfact(temp)*((1d0 - x*x)**(l/2d0))
  else 
    lminus1 = l - 1
    lminus2 = l - 2
    R = ((2*l - 1)*x*P(lminus1,m,x) - (l + m - 1)*P(lminus2,m,x))/DBLE(l - m)
  end if
END

INTEGER FUNCTION dfact(n) !Doppelfakultät
  implicit none
  integer n
  integer i
  dfact = 1
  do i=n, 1, -2
     dfact = dfact*i
  end do
END

FUNCTION f(x) RESULT (result)
    implicit none
    double precision x
    double precision result
    result = 2*x + 3*x*x + 5*x*x*x + 7
END

FUNCTION scalef(x) result (result)
  double precision result
  result = f((b - a)*x/2d0 + (a + b)/2d0)
END

RECURSIVE FUNCTION divDiff(callback, as, n) result (result)
  INTERFACE
    FUNCTION callback(x)
      DOUBLE PRECISION :: callback
      DOUBLE PRECISION :: x
    END
  END INTERFACE
  double precision as(0:*)
  integer n
  double precision result, scalef
  if (n == 0) THEN
      result = callback(as(0))
  ELSE
      result = (divDiff(callback, as(1:n), n) - divDiff(callback, as, n-1))/(as(n) - as(0))
  END IF
END

!double precision schwammerl(0:57)
!divDiff(f, schwammerl)

FUNCTION normGaussIntegrate(a, b, h) result (Summe)
    implicit none
    integer j, n
    double precision a, b, v, h, x, Summe, scalef
    ! intervall(a,b) von f(x)
    
END

FUNCTION gaussIntegrate(a, b, h) result (Summe)
  Summe = (b - a)/2*normGaussIntegrate(-1, 1, h)
END

PROGRAM xyz
    implicit none
    double precision a, b, h, denominator, gaussIntegrate
    double precision I1
    double precision I2
    double precision I
    double precision pi
    pi = 4d0*atan(1d0)
    a = 0d0
    b = 2d0*pi
    h = (b - a)
    I1 = gaussIntegrate(a, b, h)
    WRITE(*,*) I1
END

