FUNCTION f(x) RESULT (result)
    implicit none
    double precision x
    double precision result
    result = 7 + 2*x + 3*x*x + 4*x*x*x
END

FUNCTION scalef(t, a, b) result (result)
  implicit none
  double precision result, t, a, b, f
  double precision v
  v = (b - a)*t/2d0 + (a + b)/2d0
  result = f(v)
END

FUNCTION normGaussIntegrate(a, b) result (result)
    implicit none
    double precision result
    double precision a1, a2, w1, w2, a, b, scalef
    a1 = 1d0/DSQRT(3d0)
    a2 = -1d0/DSQRT(3d0)
    w1 = 1d0
    w2 = 1d0
    ! intervall(a,b) von f(x)
    result = scalef(a1, a, b)*w1 + scalef(a2, a, b)*w2
END

FUNCTION gaussIntegrate(a, b) result (result)
  implicit none
  double precision a, result
  double precision b, scalef, normGaussIntegrate
  result = ((b - a)/2d0)*normGaussIntegrate(a, b)
END
! int(-1,1) f[x] dx = f[a1]*w1+f[a2]*w2   als Ansatz


PROGRAM xyz
    implicit none
    double precision a, b, gaussIntegrate, normGaussIntegrate
    double precision I
    double precision pi
    pi = 4d0*atan(1d0)
    a = 0d0
    b = 2d0
    I = gaussIntegrate(a, b)
    WRITE(*,*) I
END

