#!/usr/bin/env python
from __future__ import division
from cmath import sqrt, exp
from a import solveLinearEquation
import sys

def V(x):
  if (10 < x and x < 14):
    return 10.0
  else:
    return 0.0
def zeroBorder(psixs, mmin, mmax):
  for m in range(int(mmin), int(mmax)):
    psixs[m] = 0
  print >>sys.stderr, psixs
def psi0(x):
  pi = 3.141592653589793
  sigma = 2.0
  k0 = 1.0
  return  1.0/(sqrt(sigma*sqrt(pi)))*exp(-x**2/(2*sigma**2))*exp(1j*k0*x)
if True:
  xmin = -22
  xmax = 22
  xrange = xmax - xmin
  xresolution = 200
  tmin = 0
  tmax = 2
  trange = tmax - tmin
  tresolution = 200
  psixs = [0 for i in range(xresolution)]
  dt = trange/tresolution
  dx = xrange/xresolution
  tau = dt/(dx*dx)
  inhomogenity = [0 for i in range(xresolution)]
  # calculate psi for starting time
  for m in range(xresolution):
    x = xmin + m*dx
    psixs[m] = psi0(x)
  zeroBorder(psixs, (-22 - xmin)/dx, (-5 - xmin)/dx)
  zeroBorder(psixs, (5 - xmin)/dx, (22 - xmin)/dx)
  for m in range(xresolution):
    x = xmin + m*dx
    v = psixs[m]
    print 0.0, x, (v.conjugate()*v).real
  print ""
  print ""
  # do time evolution
  for n in range(1, xresolution):
    t = tmin + n*dt
    # calculate inhomogenity
    for m in range(xresolution):
      x = xmin + m*dx
      inhomogenity[m] = psixs[m] - (1.0j)*dt*V(x)*psixs[m]
    # calculate psi for next time moment
    # solve (1 + I tau A) psi2 = psi - i dt V psi for psi2
    for m in range(xresolution):
      x = xmin + m*dx
      psixs[m] = solveLinearEquation(tau, inhomogenity, m)
      v = psixs[m]
      print t, x, (v.conjugate()*v).real
    zeroBorder(psixs, (-22 - xmin)/dx, (-5 - xmin)/dx)
    zeroBorder(psixs, (5 - xmin)/dx, (22 - xmin)/dx)
    print ""
    print ""
