PROGRAM harmonOszillator
  IMPLICIT NONE
  ! EW berechnen
  COMPLEX*16 s0(0:999)
  COMPLEX*16 diagMain(0:999)
  COMPLEX*16 diagLower(0:999)
  COMPLEX*16 A(0:999,0:999)
  COMPLEX*16 eigenvalue
  INTEGER sVectorSize
  DOUBLE PRECISION xmin
  DOUBLE PRECISION xmax
  DOUBLE PRECISION xrange
  DOUBLE PRECISION dx
  INTEGER xresolution
  INTEGER diagSize
  INTEGER k
  PARAMETER (xmin = -22D0)
  PARAMETER (xmax = 22D0)
  PARAMETER (xrange = xmax - xmin)
  PARAMETER (xresolution = 100)
  PARAMETER (dx = xrange/xresolution)
  ! initialize matrix from tridiagonal row vectors of -psi''/2 + V psi = E psi for V = m² omega² x²/2
  CALL initTriMatrix(A, xresolution, xmin, xmax, dx)
  sVectorSize = xresolution
  CALL initVector1(s0, 0, DCMPLX(1.0D0, 1.0D0), xresolution)
  diagSize = 2 ! TODO
  DO k = 1,10,1
    CALL getLanczosBase(A, sVectorSize, s0, diagMain, diagLower, diagSize, eigenvalue)
  END DO
END
SUBROUTINE getTriEigenvector(diagMain, diagLower, diagSize, eigenvalue, dest)
  COMPLEX*16 :: diagMain(0:*) 
  COMPLEX*16 :: diagLower(0:*)
  INTEGER diagSize
  COMPLEX*16 eigenvalue 
  COMPLEX*16, intent(out) :: dest(0:*)
  ! FIXME this assumes that the matrix is 2x2.
  ! FIXME avoid division by zero by swapping rows
  WRITE(*,*) "[[", diagMain(0), diagLower(0), "] [", diagLower(0), diagMain(1), "]]"
  IF (ABS(diagMain(1) - eigenvalue - diagLower(0)*diagLower(0)/(diagMain(0) - eigenvalue)) .LT. 0.01) THEN
    WRITE(*,*) "EV"
    dest(1) = 1D0
    dest(0) = -diagLower(0)/(diagMain(0) - eigenvalue)
  ELSE
    WRITE(*,*) "no Eigenvector possible"
    CALL initVector(dest, DCMPLX(0D0, 0D0), diagSize)
  END IF
  CALL printVector("Eigenvector", dest, diagSize)
  WRITE(*,*) "testing gives", (diagMain(0) - eigenvalue)*dest(0) + diagLower(0)*dest(1)
  WRITE(*,*) "testing 2", diagLower(0)*dest(0) + (diagMain(1) - eigenvalue)*dest(1)
END
! initializes the tridiagonal matrix using the given discretisation 
SUBROUTINE initTriMatrix(A, xresolution, xmin, xmax, dx)
  COMPLEX*16,intent(out) :: A(0:999,0:999)
  INTEGER i
  INTEGER xresolution
  DOUBLE PRECISION x
  DOUBLE PRECISION dx
  CALL initMatrix(A, DCMPLX(0,0), 1000, 1000)
  DO i = 0, xresolution - 1
    x = xmin + i*dx
    A(i, i) = 1/dx**2 + x**2
    IF (I .GE. 1) THEN
      A(i - 1, i) = -1/(2*dx**2)
    END IF
    A(i + 1, i) = -1/(2*dx**2)
  END DO
END
! sinit ... Starting Vector, modified to new starting vector
! sVectorSize ... Dimension 1 Vektor in s = dimension of A
! diagSize ... size of diagMain
SUBROUTINE getLanczosBase(A, sVectorSize, sinit, diagMain, diagLower, diagSize, eigenvalue)
  IMPLICIT NONE
  INTEGER sVectorSize
  COMPLEX*16 A(0:999, 0:999) ! aDimension*aDimension
  COMPLEX*16 tinit(0:diagSize - 1)
  COMPLEX*16, intent(out) :: diagMain(0:*)
  COMPLEX*16, intent(out) :: diagLower(0:*)
  COMPLEX*16, intent(inout) :: sinit(0:sVectorSize - 1)
  COMPLEX*16 s(0:sVectorSize - 1)
  COMPLEX*16 prevS(0:sVectorSize - 1)
  COMPLEX*16 q(0:sVectorSize - 1)
  COMPLEX*16 Qm(0:888, 0:888)
  COMPLEX*16 qtmp(0:sVectorSize - 1)
  COMPLEX*16 qtmp2(0:sVectorSize - 1)
  COMPLEX*16 qtmp3(0:sVectorSize - 1)
  COMPLEX*16 prevDiagLowerElement
  COMPLEX*16, intent(out) :: eigenvalue
  INTEGER diagSize
  INTEGER i
  DOUBLE PRECISION norm
  COMPLEX*16 scalarProduct
  DOUBLE PRECISION getTriLowerEigenvalue
  CALL copyVector(s, sinit, sVectorSize)
  WRITE(*,*) "S", s(0), s(1), s(2)
  CALL initVector(q, DCMPLX(0D0, 0D0), sVectorSize) ! q = 0
  prevDiagLowerElement = norm(s, sVectorSize)
  WRITE(*,*) "DL0", prevDiagLowerElement
  DO i = 0, diagSize - 1
    WRITE(*,*) "iteration..."
    !q(i) = s(i - 1)/diagLower(i - 1)
    !s(i) = Aq(i) - diagLower(i - 1)*q(i - 1)
    !alpha(I) = q(i)^T*s(i)
    !s(i) = s(i) - diagMain(i)*q(i)
    !beta(i) = norm(s(i)) ! i <= m - 1

    !qtmp2 = diagLower(i - 1)*q(i - 1)
    !q(i) = s(i - 1)/diagLower(i - 1)
    !s(i) = Aq(i) - qtmp2
    !alpha(I) = q(i)^T*s(i)
    !s(i) = s(i) - diagMain(i)*q(i)
    !beta(i) = norm(s(i)) ! i <= m - 1

    CALL copyVector(prevS, s, sVectorSize)
    CALL scalarMultiply(prevDiagLowerElement, q, qtmp2, sVectorSize) ! qtmp2 = diagLower(i - 1)*q !(i-1)
    CALL scalarMultiply(DCMPLX(1D0, 0D0)/prevDiagLowerElement, prevS, q, sVectorSize) ! q = prevS/prevDiagLowerElement
    CALL copyColumnVectorToMatrix(Qm, i, q, sVectorSize)
    !CALL printMatrix("A", A, sVectorSize, sVectorSize)
    !CALL printVector("q", q, sVectorSize)
    CALL multiplyMatrixVector(A, q, qtmp3, sVectorSize, sVectorSize) ! qtmp3 = A q
    !CALL printVector("qtmp3", qtmp3, sVectorSize)
    CALL subtractVectors(qtmp3, qtmp2, s, sVectorSize) ! s = Aq - qtmp2
    !CALL printVector("S", s, sVectorSize)
    diagMain(i) = scalarProduct(q, s, sVectorSize)
    WRITE(*,*) "scalarProduct said", diagMain(i) 
    CALL scalarMultiply(diagMain(i), q, qtmp, sVectorSize)
    CALL subtractVectors(s,qtmp,s,sVectorSize) ! s = s - qtmp
    !CALL printVector("S", s, sVectorSize)
    diagLower(i) = norm(s, sVectorSize) ! i <= m - 1
    prevDiagLowerElement = diagLower(i)
  END DO
  WRITE(*,*) "all iterations done"
  ! H = matrixMul(Q^T, A, Q)  with diagUpper, diagMain, diagLower around the diagonal.
  eigenvalue = getTriLowerEigenvalue(diagMain, diagLower, diagSize)
  CALL getTriEigenvector(diagMain, diagLower, diagSize, eigenvalue, tinit)
  CALL makeVectorLengthUnit(tinit, diagSize)
  CALL multiplyMatrixVector(Qm, tinit, sinit, sVectorSize, diagSize)
END
! assumes matrix is symmetric
DOUBLE PRECISION FUNCTION getTriLowerEigenvalue(diagMain, diagLower, N) RESULT (result)
  IMPLICIT NONE
  COMPLEX*16 diagMain(0:*)
  COMPLEX*16 diagLower(0:*)
  INTEGER N
  DOUBLE PRECISION eigenvalues(0:N - 1) 
  COMPLEX*16 middle
  ! FIXME assumes N = 2
  middle = (diagMain(1) + diagMain(0))/2D0 
  eigenvalues(0) =DBLE(middle + sqrt((diagLower(0) + diagMain(0))**2 - 4*(diagMain(0)*diagMain(1) - diagLower(0)*diagLower(0)))/2D0)
  eigenvalues(1) =DBLE(middle + sqrt((diagLower(0) + diagMain(0))**2 - 4*(diagMain(0)*diagMain(1) - diagLower(0)*diagLower(0)))/2D0)
  IF (eigenvalues(0) .LT. eigenvalues(1)) THEN
    result = eigenvalues(0)
  ELSE
    result = eigenvalues(1)
  END IF
END
! assumes matrix is symmetric
COMPLEX*16 FUNCTION getTriEigenvalue(diagMain, diagLower, N) RESULT (result)
  IMPLICIT NONE
  INTEGER N
  COMPLEX*16 diagMain(0:*)
  COMPLEX*16 diagLower(0:*)
  COMPLEX*16 getCharacteristicPolynomZero
  WRITE(*,*) "N", N
  result = getCharacteristicPolynomZero(N, diagMain, diagLower)
END
SUBROUTINE copyVector(dest, source, sVectorSize)
  IMPLICIT NONE
  INTEGER i
  INTEGER sVectorSize
  COMPLEX*16, intent(out) :: dest(0:*)
  COMPLEX*16 source(0:*)
  DO i = 0, sVectorSize - 1
    dest(i) = source(i)
  END DO
END
SUBROUTINE copyColumnVectorToMatrix(Qm, i, q, sVectorSize)
  INTEGER i
  INTEGER sVectorSize
  INTEGER j
  COMPLEX*16, intent(inout) :: Qm(0:888, 0:888)
  COMPLEX*16 q(0:sVectorSize - 1)
  DO j=0,sVectorSize - 1,1
    Qm(j,i) = q(j)
  END DO
END
SUBROUTINE initVector(dest, initValue, sVectorSize)
  IMPLICIT NONE
  COMPLEX*16 initValue
  INTEGER i
  INTEGER sVectorSize
  COMPLEX*16, intent(out) :: dest(0:*)
  DO i = 0, sVectorSize - 1
    dest(i) = initValue
  END DO
END
SUBROUTINE initVector1(dest, index, initValue, sVectorSize)
  IMPLICIT NONE
  COMPLEX*16 initValue
  INTEGER i
  INTEGER index
  INTEGER sVectorSize
  COMPLEX*16, intent(out) :: dest(0:*)
  DO i = 0, sVectorSize - 1
    dest(i) = DCMPLX(0D0, 0D0)
  END DO
  dest(index) = initValue
END
COMPLEX*16 FUNCTION scalarProduct(a, b, vectorSize) RESULT (result)
  IMPLICIT NONE
  INTEGER vectorSize
  COMPLEX*16 a(0:*)
  COMPLEX*16 b(0:*)
  INTEGER i
  result = DCMPLX(0, 0)
  DO i = 0,vectorSize - 1
    result = result + a(i)*b(i)
  END DO
END
SUBROUTINE scalarMultiply(scalar, source, dest, vectorSize)
  IMPLICIT NONE
  INTEGER vectorSize
  COMPLEX*16 scalar
  COMPLEX*16 source(0:*)
  COMPLEX*16, intent(out) :: dest(0:*)
  INTEGER i
  DO i = 0,vectorSize - 1
    dest(i) = scalar*source(i)
  END DO
END
DOUBLE PRECISION FUNCTION norm(x, xVectorSize) RESULT (result)
  IMPLICIT NONE
  INTEGER i
  INTEGER xVectorSize
  COMPLEX*16 x(0:*)
  result = DCMPLX(0, 0)
  DO i = 0, xVectorSize - 1
    result = result + CONJG(x(i))*x(i)
  END DO
  result = sqrt(REAL(result))
END
SUBROUTINE makeVectorLengthUnit(x, xVectorSize)
  IMPLICIT NONE
  DOUBLE PRECISION n
  DOUBLE PRECISION norm
  COMPLEX*16, intent(inout) :: x(0:*)
  INTEGER i
  INTEGER xVectorSize
  n = norm(x, xVectorSize)
  DO i = 0, xVectorSize - 1
    x(i) = x(i)/n
  END DO
END
SUBROUTINE subtractVectors(a, b, dest, vectorSize)
  IMPLICIT NONE
  INTEGER vectorSize
  COMPLEX*16 a(0:*)
  COMPLEX*16 b(0:*)
  COMPLEX*16, intent(out) :: dest(0:*)
  INTEGER i
  DO i = 0,vectorSize - 1
    dest(i) = a(i) - b(i)
  END DO
END
SUBROUTINE printVector(prefix, a, vectorSize)
  IMPLICIT NONE
  INTEGER vectorSize
  CHARACTER(len=*) prefix
  COMPLEX*16 a(0:*)
  INTEGER i
  WRITE(*,*) prefix
  DO i = 0,vectorSize - 1
    WRITE(*,*) a(i)
  END DO
  WRITE(*,*) "==="
END
! aRowCount row count in matrix A (= row count in vector dest).
! xVectorSize row count of vector x.
SUBROUTINE multiplyMatrixVector(A, x, dest, aRowCount, xVectorSize)
  IMPLICIT NONE
  INTEGER xVectorSize
  COMPLEX*16 A(0:999, 0:999)
  COMPLEX*16 x(0:*)
  COMPLEX*16, intent(out) :: dest(0:*)
  INTEGER aRowCount
  INTEGER i
  INTEGER j
  DO i = 0,aRowCount - 1
    dest(i) = DCMPLX(0D0, 0D0)
    DO j = 0,xVectorSize - 1
      dest(i) = dest(i) + A(i,j)*x(j)
    END DO
  END DO
END
SUBROUTINE printMatrix(prefix, A, aRowCount, aColumnCount)
  IMPLICIT NONE
  INTEGER aRowCount
  INTEGER aColumnCount
  COMPLEX*16 A(0:999, 0:999)
  CHARACTER(len=*) prefix
  INTEGER i
  INTEGER j
  WRITE(*,*) prefix
  DO i = 0,aRowCount - 1
    DO j = 0,aColumnCount - 1
      WRITE(*,*) A(i,j)
    END DO
    WRITE(*,*) ""
  END DO
  WRITE(*,*) "==="
END
SUBROUTINE initMatrix(A, s,r, c)
  IMPLICIT NONE
  COMPLEX*16,intent(out) :: A(0:999, 0:999)
  COMPLEX*16 s
  INTEGER r
  INTEGER c
  INTEGER i
  INTEGER j
  DO i = 0,r - 1
    DO j = 0,c - 1
      A(i,j) = s
    END DO
  END DO
END

! find zeroes

! P(lambda) = Pj(n, lambda)

RECURSIVE COMPLEX*16 FUNCTION Pr(diagMain, diagLower, j, lambda) RESULT (result)
  IMPLICIT NONE
  INTEGER j
  COMPLEX*16 lambda
  COMPLEX*16 diagMain(0:*)
  COMPLEX*16 diagLower(0:*)
  IF (j .EQ. 0) THEN
    result = diagMain(0) - lambda
  ELSE IF (j .EQ. 1) THEN
    result = (diagMain(1) - lambda)*Pr(diagMain, diagLower, 0, lambda) - diagLower(0)**2
  ELSE
    result = (diagMain(j) - lambda)*Pr(diagMain, diagLower, j - 1, lambda) 
    result = result - diagLower(j - 1)**2*Pr(diagMain, diagLower, j - 2,lambda)
  END IF
END
RECURSIVE COMPLEX*16 FUNCTION dPr(diagMain, diagLower, j, lambda) RESULT (result)
  IMPLICIT NONE
  INTEGER j
  COMPLEX*16 lambda
  COMPLEX*16 diagMain(0:*)
  COMPLEX*16 diagLower(0:*)
  COMPLEX*16 Pr
  IF (j .EQ. 0) THEN
    result = DCMPLX(-1, 0)
  ELSE IF (j .EQ. 1) THEN
    result = - dPr(diagMain, diagLower, 0, lambda)*diagMain(1) 
    result = result - Pr(diagMain, diagLower, 0, lambda) - lambda*dPr(diagMain, diagLower, 0, lambda)
  ELSE
    result = - Pr(diagMain, diagLower, j - 1, lambda) - lambda*dPr(diagMain, diagLower, j - 1, lambda) 
    result = result - diagLower(j - 1)**2*dPr(diagMain, diagLower, j - 2, lambda)
  END IF
END
COMPLEX*16 FUNCTION getCharacteristicPolynomZero(N, diagMain, diagLower) RESULT (lambda)
  IMPLICIT NONE
  COMPLEX*16 dlambda
  INTEGER N
  COMPLEX*16 diagMain(0:*)
  COMPLEX*16 diagLower(0:*)
  COMPLEX*16 Pr
  COMPLEX*16 dPr
  INTEGER i
  WRITE(*,*) "N", N
  DO i=0,N - 1
    WRITE(*,*) "diagMain", i, diagMain(i)
  END DO
  DO i=0,N - 2
    WRITE(*,*) "diagLower", i, diagLower(i)
  END DO
  lambda = DCMPLX(45, 0)
  DO WHILE (1 .EQ. 1)
    IF (ABS(Pr(diagMain, diagLower, N, lambda)) .LT. 0.01) THEN
      WRITE(*,*) "ok", lambda, ABS(Pr(diagMain, diagLower, N, lambda))
      EXIT
    END IF
    WRITE(*,*) "ungenau", lambda, ABS(Pr(diagMain, diagLower, N, lambda)), dPr(diagMain, diagLower, N, lambda)
    dlambda = Pr(diagMain, diagLower, N, lambda)/dPr(diagMain, diagLower, N, lambda)
    lambda = lambda - dlambda
  END DO
END

