PROGRAM pendel
 IMPLICIT NONE
 DOUBLE PRECISION z(0:2), y(0:2), k1(0:2), k2(0:2), k3(0:2), k4(0:2)
 DOUBLE PRECISION Phi(0:2)
 DOUBLE PRECISION tmin, tmax, dt, t, Omega, w0, theta0, eta, f, g, L, h
 DOUBLE PRECISION dampening, mass, wmin, wmax, dw, w
 DOUBLE PRECISION PhaseVolume, theta_min, theta_max, calculatePhasevolume
 COMPLEX*16 Fouriersumme(0:1999)
 INTEGER tcount, i, wcount, j
 
 WRITE(*,*) "Select Parameters for Pendulum"
  
 WRITE(*,*) "Mass ="
 READ(*,*) mass
 WRITE(*,*) "Length ="
 READ(*,*) L
 !WRITE(*,*) "theta0 ="
 !READ(*,*) theta0
 WRITE(*,*) "dampening eta ="
 READ(*,*) eta
 WRITE(*,*) "Driver ="
 READ(*,*) f
 WRITE(*,*) "driver frequency ="
 READ(*,*) Omega
 
 !mass = 1D-9
 g = 9.80665D0 !m/(s*s)
 h = 6.626076D-34
 !L = 5D-3
 dampening = 0D0
 !Omega = 0D0
 w0 = DSQRT(g/L)
 !theta0 = 2D0
 theta0 = DSQRT(h/(2D0*3.141592D0*mass*w0))/L !erforderliches Theta, um Weylesche Regel zu verifizieren
 !eta = dampening/(2D0*mass)
 !eta = 0D0
 !f = 0D0
 
 z(0) = 0D0
 z(1) = theta0
 z(2) = 0D0
 
 tmin = 0D0
 tmax = 2D0
 dt = 0.001D0
 tcount = (tmax-tmin)/dt
 theta_max = z(1)
 theta_min = z(1)
 wcount = 2000
 wmax = 200D0
 wmin = 0D0
 dw = (wmax-wmin)/wcount
 
 DO j = 0, wcount - 1
   w = j*dw + wmin
   Fouriersumme(j) = -dt*ZEXP(DCMPLX(0,w*t))*z(1)/2D0
 END DO
 
 OPEN(11, FILE="datei", STATUS='REPLACE')
 
 DO i = 0, tcount - 1
 
  t = i*dt + tmin
  z(0) = t
 
  WRITE(11,*) t, z(1), z(2)
  
  DO j = 0, wcount - 1
   w = j*dw + wmin
   Fouriersumme(j) = Fouriersumme(j) + dt*ZEXP(DCMPLX(0,w*t))*z(1)
  END DO
   
  IF (z(1) > theta_max) THEN
   theta_max = z(1)
  END IF
  
  IF (z(1) < theta_min) THEN
   theta_min = z(1)
  END IF
 
  y(0)=z(0)
  y(1)=z(1)
  y(2)=z(2)
 
  k1(0) = 1D0
  k1(1) = y(2)
  k1(2) = f*DSIN(Omega*y(0)) - 2D0*eta*y(2) - w0*w0*DSIN(y(1))
  
  !WRITE(*,*) "k1", k1(0), k1(1), k1(2)

  y(0)=z(0)+dt*k1(0)/2.d0
  y(1)=z(1)+dt*k1(1)/2.d0
  y(2)=z(2)+dt*k1(2)/2.d0
  
  k2(0) = 1D0
  k2(1) = y(2)
  k2(2) = f*DSIN(Omega*y(0)) - 2D0*eta*y(2) - w0*w0*DSIN(y(1))
  
  !WRITE(*,*) "k2", k2(0), k2(1), k2(2)
  
  y(0)=z(0)+dt*k2(0)/2.d0
  y(1)=z(1)+dt*k2(1)/2.d0
  y(2)=z(2)+dt*k2(2)/2.d0
  
  k3(0) = 1D0
  k3(1) = y(2)
  k3(2) = f*DSIN(Omega*y(0)) - 2D0*eta*y(2) - w0*w0*DSIN(y(1))
  
  !WRITE(*,*) "k3", k3(0), k3(1), k3(2)
  
  y(0)=z(0)+dt*k3(0)
  y(1)=z(1)+dt*k3(1)
  y(2)=z(2)+dt*k3(2)
  
  k4(0) = 1D0
  k4(1) = y(2)
  k4(2) = f*DSIN(Omega*y(0)) - 2D0*eta*y(2) - w0*w0*DSIN(y(1))
  
  !WRITE(*,*) "k4", k4(0), k4(1), k4(2)
 
 
  Phi(0) = 1D0/6D0*(k1(0) + 2D0*k2(0) + 2D0*k3(0) + k4(0))
  Phi(1) = 1D0/6D0*(k1(1) + 2D0*k2(1) + 2D0*k3(1) + k4(1))
  Phi(2) = 1D0/6D0*(k1(2) + 2D0*k2(2) + 2D0*k3(2) + k4(2))
  
  !WRITE(*,*) "Phi", Phi(0), Phi(1), Phi(2)
 
  z(0) = z(0) + dt*Phi(0)
  z(1) = z(1) + dt*Phi(1)
  z(2) = z(2) + dt*Phi(2)
 
 END DO
 
 CLOSE(11)
 
 OPEN(12, FILE="dateiFourier", STATUS='REPLACE')
 
 DO j = 0, wcount - 1
   w = j*dw + wmin
   Fouriersumme(j) = Fouriersumme(j) - dt*ZEXP(DCMPLX(0,w*t))*z(1)/2D0
   WRITE(12,*) w, abs(Fouriersumme(j))
 END DO
 
 CLOSE(12)

 PhaseVolume = calculatePhasevolume(L*theta_min, L*theta_max, mass, w0) !Verifizieren der Weyleschen Regel, Dämpfung und Treiber müssen Null gesetzt werden
 
 WRITE (*,*) "Phasenraumvolumen = ", PhaseVolume
 WRITE(*,*) "h/2", h/2D0

END


DOUBLE PRECISION FUNCTION calculatePhasevolume(qmin, qmax, mass, w0) RESULT(summe)
 IMPLICIT NONE
 DOUBLE PRECISION summe, qmin, qmax, mass, w0, h, q, dq
 INTEGER i, qcount
 h = 6.626076D-34
 qcount = 200
 summe = 0D0
 dq = (qmax-qmin)/qcount
 DO i = 0, qcount - 1
  q = i*dq + qmin
  summe = summe + dq*DSQRT(2*mass*h*w0/(4*3.141592D0)-mass*mass*w0*w0*q*q)
 END DO
 summe = summe - dq*DSQRT(2*mass*h*w0/(4*3.141592D0)-mass*mass*w0*w0*qmin*qmin)/2D0
 summe = summe - dq*DSQRT(2*mass*h*w0/(4*3.141592D0)-mass*mass*w0*w0*qmax*qmax)/2D0
 summe = 2D0*summe
END
