#!/usr/bin/env python

from memo import memoized
from math import sqrt

dCloseEnoughToZero = 1E-12
normSquareCloseToZero = 1E-1
ulinks = 0
urechts = 10E0
nLimit = 4000
c = 2.99792458E8
hbarc = 197.327053E-9
hbar = hbarc/c
g = 9.80665
mcsq = 939.56563E6
m = mcsq/(c*c)
h = 0 # ! = 0.1E0 ! automatisch
E0 = (m*g**2*hbar**2/2E0)**(1E0/3E0)
def getSpanIndex(z):
	return (z - ulinks)//h

def findAllResults(aepsillinks, epsilrechts, roh0):
 epsillinks = aepsillinks
 OPEN(11, FILE="L", STATUS="REPLACE")
 for i in range(4):
  epsil = findLowestEpsilon(epsillinks, epsilrechts, roh0)
  if (abs(u(0, epsil, roh0)) < dCloseEnoughToZero):
    epsils(i) = epsil
    WRITE(*,*) "Eigenenergie: ", epsil*E0*1D12, " peV"      ! <-- (un)comment to use
    CALL writeNormU(epsil, roh0)                             ! <-- (un)comment to use
  else:
    !WRITE(*,*) "???", epsil, abs(u(0, epsil, roh0))
    EXIT
  ! u(0, epsillinks) > 0 sicherstellen
  epsillinks = findEpsilonWithUAbove(epsil, epsilrechts, roh0)
  if (epsilrechts .LT. epsillinks):
    EXIT
  !h = h/2
  !nLimit = nLimit*2
  !WRITE(*,*) "===="
 CLOSE(11)
 WRITE(*,*) "(siehe Datei 'L' für die normierten Wellenfunktionen)"
 allOrthogonal = .TRUE.
 for i in range(4):
   for j in range(4):
     r = integrateUsquareBySimpson(ulinks, urechts, 0.001D0, epsils(i), epsils(j), roh0)
     r = r/DSQRT(integrateUsquareBySimpson(ulinks, urechts, 0.001D0, epsils(i), epsils(i)))
     r = r/DSQRT(integrateUsquareBySimpson(ulinks, urechts, 0.001D0, epsils(j), epsils(j)))
     if (i .EQ. j):
       if (r .LT. normSquareCloseToZero):
         allOrthogonal = .FALSE.
     else: ! should be orthogonal
       if (r .GE. normSquareCloseToZero):
         allOrthogonal = .FALSE.
 if(not allOrthogonal):
   WRITE(*,*) "keine orthonormierten Ergebnisse"
# Voraussetzung: u(0,alinks)*u(0,arechts)<0
def findLowestEpsilon(alinks, arechts, roh0):
 USE globals
 INTEGER i
 u
 findEpsilon
 roh0
 , intent(in) :: alinks, arechts
 :: epsillinks, epsilrechts
 :: epsil
 findEpsilonWithUBelow
 epsillinks = alinks
 epsilrechts = arechts
 epsil = 0D0
 DO i = 0, 5000, 1
   prevEpsil = epsil
   epsil = findEpsilon(epsillinks, epsilrechts, roh0)
   if (abs(u(0, epsil, roh0)) .ge. dCloseEnoughToZero): ! wir nehmen an, es existiert gar keine passende Wellenfunktion mehr.
     EXIT
   ! u(0, epsilrechts) < 0 sicherstellen
   epsilrechts = findEpsilonWithUBelow(epsillinks, epsil, roh0)
   if (epsilrechts .LE. epsillinks):
     EXIT
 END DO
 return prevEpsil
def findEpsilonWithUBelow(epsillinks, aepsil, roh0):
  result = aepsil
  result = result - 0.00001D0
  DO WHILE (u(0, result, roh0) .GE. 0D0 .AND. result .GE. epsillinks)
    result = result - 0.00001D0
  END DO
  return(result)
def findEpsilonWithUAbove(aepsil, epsilrechts, roh0):
  result = aepsil
  result = result + 0.00001D0
  DO WHILE (u(0, result, roh0) .LE. 0D0 .AND. result .LE. epsilrechts)
    result = result + 0.00001D0
  END DO
  return(result)

# Voraussetzung: u(0,alinks)*u(0,arechts)<0
def findEpsilon(alinks, arechts, roh0) RESULT (epsil)
 epsillinks = alinks
 epsilrechts = arechts
 for i in range(10001):
  prevLinks = epsillinks
  prevRechts = epsilrechts
  epsil = (epsilrechts + epsillinks)/2D0
  !WRITE(*,*) "findEpsilon is at epsil", epsil, epsillinks, epsilrechts
  if (abs(u(0, epsil, roh0)) < dCloseEnoughToZero):
   !WRITE(*,*) "OK", epsil, abs(u(0, epsil, roh0))
   exit
  else: if (u(0, epsillinks, roh0)*u(0, epsil, roh0) .LT. 0D0):
   epsilrechts = epsil
  else: 
   epsillinks = epsil
  if(epsillinks .EQ. prevLinks .AND. epsilrechts .EQ. prevRechts):
    EXIT
  !WRITE (*,*) epsillinks, epsilrechts
 END DO
 if(i .GT. 10000):
   !WRITE(*,*) "(aufgegeben)", epsil, abs(u(0, epsil, roh0))

#w(n+1) = epsil - (roh(n+1) - roh0)
#Q(n+1) = (1D0 + h*h/12D0*w(n+1))*u(n+1)
#Q(n+1) = 12D0*u(n) - 10D0*Q(n) - Q(n-1)
#Q(n) = 12D0*u(n+1) - 10D0*Q(n+1) - Q(n+2)
def w(n, epsil, roh0):
 return epsil - (roh(n, roh0) - roh0)
def roh(n, roh0):
 return roh0 + n*h
def Qvonu(n, epsil, roh0):
 return (1D0 + h*h/12D0*w(n, epsil, roh0))*u(n, epsil, roh0)
def clearQCache():
 global previousResults
 global previousResultKnowns
 global previousEpsils
 DO i=0,9999,1
   previousResultKnowns(i) = .FALSE.
   previousResults(i) = 42D0
   previousEpsils(i) = 0D0
 END DO
def Q(n, epsil, roh0):
 global previousResults
 global previousResultKnowns
 global previousEpsils
 if (previousResultKnowns(n) .AND. previousEpsils(n) .EQ. epsil):
   result = previousResults(n)
 else:
   previousEpsils(n) = epsil
   if (n .eq. nLimit):
      result = Qvonu(n, epsil, roh0)
   else: if (n .eq. nLimit - 1):
      result = Qvonu(n, epsil, roh0)
   else: 
      result = 12D0*u(n+1, epsil, roh0) - 10D0*Q(n+1, epsil, roh0) - Q(n+2, epsil, roh0)
   previousResults(n) = result
   previousResultKnowns(n) = .TRUE.
def u(n, epsil, roh0):
 if (n .eq. nLimit):
  result = 0D0
 else: if (N .eq. nLimit - 1):
  result = 1D-10
 else: 
  result = Q(n, epsil, roh0)/(1D0 + h*h/12D0*w(n, epsil, roh0))
def integrateUsquareBySimpson(left, right, dz, aepsil, bepsil, roh0) RESULT(result)
  ua(0:99999)
  INTEGER i
  count = (right - left)/dz
  DO i = getSpanIndex(left), getSpanIndex(right), 1
    ua(i) = u(i, aepsil, roh0)
  END DO
  ! int f(x) dx = dz/3 * (f(x_0) + 4 f(x_1) + 2 f(x_2) + 4 f(x_3) + ... + 4 f(x_n-1) + f(x_n))
  result = ua(getSpanIndex(left))*u(getSpanIndex(left), bepsil, roh0)
  DO i = 1,count - 1,1
    if (MOD(i, 2) .EQ. 0):
      factor = 2D0
    else:
      factor = 4D0
    z = left + dz*i
    result = result + factor*(ua(getSpanIndex(z))*u(getSpanIndex(z), bepsil, roh0))
  END DO
  result = result + ua(getSpanIndex(right))*u(getSpanIndex(right), bepsil, roh0)
  result = result*dz/3
def writeNormU(epsil, roh0):
  length = DSQRT(integrateUsquareBySimpson(ulinks, urechts, 0.001D0, epsil, epsil, roh0))
  DO i = 0, nLimit - 1, 1
    WRITE (11,*) roh(i, roh0), u(i, epsil, roh0)/length
  END DO
  WRITE (11,*) ""
  WRITE (11,*) ""
if __name__ == "__main__":
	clearQCache()
	h = (urechts - ulinks)/DBLE(nLimit)
	findAllResults(0D0, 30D0, 0.1D0)

