#!/usr/bin/env python
# -*- coding: utf-8 -*-

from memo import memoized
from math import sqrt

dCloseEnoughToZero = 1E-12
normSquareCloseToZero = 1E-1
ulinks = 0
urechts = 10E0
nLimit = 4000
c = 2.99792458E8
hbarc = 197.327053E-9
hbar = hbarc/c
g = 9.80665
mcsq = 939.56563E6
m = mcsq/(c*c)
h = 0 # ! = 0.1E0 ! automatisch
E0 = (m*g**2*hbar**2/2E0)**(1E0/3E0)
def getSpanIndex(z):
	return (z - ulinks)//h

output1 = None
def findAllResults(aepsillinks, epsilrechts, roh0):
 epsillinks = aepsillinks
 global output1
 output1 = open("L", "w")
 epsils = [0,0,0,0]
 for i in range(4):
  epsil = findLowestEpsilon(epsillinks, epsilrechts, roh0)
  if (abs(u(0, epsil, roh0)) < dCloseEnoughToZero):
    epsils[i] = epsil
    print "Eigenenergie: ", epsil*E0*1E12, " peV"
    writeNormU(epsil, roh0)
  else:
    #print "???", epsil, abs(u(0, epsil, roh0))
    break
  # u(0, epsillinks) > 0 sicherstellen
  epsillinks = findEpsilonWithUAbove(epsil, epsilrechts, roh0)
  if (epsilrechts < epsillinks):
    break
  #h = h/2
  #nLimit = nLimit*2
  #print "===="
 output1.close()
 print "(siehe Datei 'L' für die normierten Wellenfunktionen)"
 allOrthogonal = True
 for i in range(4):
   for j in range(4):
     r = integrateUsquareBySimpson(ulinks, urechts, 0.001E0, epsils(i), epsils(j), roh0)
     r = r/DSQRT(integrateUsquareBySimpson(ulinks, urechts, 0.001E0, epsils(i), epsils(i)))
     r = r/DSQRT(integrateUsquareBySimpson(ulinks, urechts, 0.001E0, epsils(j), epsils(j)))
     if (i .EQ. j):
       if (r < normSquareCloseToZero):
         allOrthogonal = False
     else: # should be orthogonal
       if (r >= normSquareCloseToZero):
         allOrthogonal = False
 if(not allOrthogonal):
   print "keine orthonormierten Ergebnisse"
# Voraussetzung: u(0,alinks)*u(0,arechts)<0
def findLowestEpsilon(alinks, arechts, roh0):
 epsillinks = alinks
 epsilrechts = arechts
 epsil = 0E0
 for i in range(5001):
   prevEpsil = epsil
   epsil = findEpsilon(epsillinks, epsilrechts, roh0)
   if (abs(u(0, epsil, roh0)) .ge. dCloseEnoughToZero): # wir nehmen an, es existiert gar keine passende Wellenfunktion mehr.
     break
   # u(0, epsilrechts) < 0 sicherstellen
   epsilrechts = findEpsilonWithUBelow(epsillinks, epsil, roh0)
   if (epsilrechts <= epsillinks):
     break
 return prevEpsil
def findEpsilonWithUBelow(epsillinks, aepsil, roh0):
  result = aepsil
  result = result - 0.00001E0
  while (u(0, result, roh0) >= 0E0 and result >= epsillinks):
    result = result - 0.00001E0
  return(result)
def findEpsilonWithUAbove(aepsil, epsilrechts, roh0):
  result = aepsil
  result = result + 0.00001E0
  while (u(0, result, roh0) <= 0E0 and result <= epsilrechts):
    result = result + 0.00001E0
  return(result)

# Voraussetzung: u(0,alinks)*u(0,arechts)<0
def findEpsilon(alinks, arechts, roh0):
 epsillinks = alinks
 epsilrechts = arechts
 for i in range(10001):
  prevLinks = epsillinks
  prevRechts = epsilrechts
  epsil = (epsilrechts + epsillinks)/2E0
  #print "findEpsilon is at epsil", epsil, epsillinks, epsilrechts
  if (abs(u(0, epsil, roh0)) < dCloseEnoughToZero):
   #print "OK", epsil, abs(u(0, epsil, roh0))
   exit
  elif (u(0, epsillinks, roh0)*u(0, epsil, roh0) < 0E0):
   epsilrechts = epsil
  else: 
   epsillinks = epsil
  if(epsillinks .EQ. prevLinks .AND. epsilrechts .EQ. prevRechts):
    break
  #print epsillinks, epsilrechts
 if(i > 10000):
   #print "(aufgegeben)", epsil, abs(u(0, epsil, roh0))
   pass
 return(epsil)

#w(n+1) = epsil - (roh(n+1) - roh0)
#Q(n+1) = (1E0 + h*h/12E0*w(n+1))*u(n+1)
#Q(n+1) = 12D0*u(n) - 10D0*Q(n) - Q(n-1)
#Q(n) = 12D0*u(n+1) - 10D0*Q(n+1) - Q(n+2)
def w(n, epsil, roh0):
 return epsil - (roh(n, roh0) - roh0)
def roh(n, roh0):
 return roh0 + n*h
def Qvonu(n, epsil, roh0):
 return (1E0 + h*h/12E0*w(n, epsil, roh0))*u(n, epsil, roh0)
@memoized
def Q(n, epsil, roh0):
   if (n == nLimit):
      result = Qvonu(n, epsil, roh0)
   elif (n == nLimit - 1):
      result = Qvonu(n, epsil, roh0)
   else: 
      result = 12E0*u(n+1, epsil, roh0) - 10E0*Q(n+1, epsil, roh0) - Q(n+2, epsil, roh0)
def u(n, epsil, roh0):
 if (n == nLimit):
  result = 0E0
 elif (N == nLimit - 1):
  result = 1E-10
 else: 
  result = Q(n, epsil, roh0)/(1E0 + h*h/12E0*w(n, epsil, roh0))
def integrateUsquareBySimpson(left, right, dz, aepsil, bepsil, roh0):
  count = (right - left)/dz
  ua = [u(i, aepsil, roh0) for i in range(getSpanIndex(left), getSpanIndex(right) + 1)]
  # int f(x) dx = dz/3 * (f(x_0) + 4 f(x_1) + 2 f(x_2) + 4 f(x_3) + ... + 4 f(x_n-1) + f(x_n))
  result = ua(getSpanIndex(left))*u(getSpanIndex(left), bepsil, roh0)
  for i in range(count):
    if ((i % 2) == 0):
      factor = 2E0
    else:
      factor = 4E0
    z = left + dz*i
    result = result + factor*(ua(getSpanIndex(z))*u(getSpanIndex(z), bepsil, roh0))
  result = result + ua(getSpanIndex(right))*u(getSpanIndex(right), bepsil, roh0)
  result = result*dz/3
  return(result)
def writeNormU(epsil, roh0):
  length = sqrt(integrateUsquareBySimpson(ulinks, urechts, 0.001E0, epsil, epsil, roh0))
  for i in range(nLimit):
    print >>output1, roh(i, roh0), u(i, epsil, roh0)/length
  print >>output1, ""
  print >>output1, ""
if __name__ == "__main__":
	clearQCache()
	h = (urechts - ulinks)/DBLE(nLimit)
	findAllResults(0E0, 30E0, 0.1E0)

