PROGRAM neutron
 IMPLICIT NONE
 INTEGER n
 DOUBLE PRECISION epsil, roh0, h
 DOUBLE PRECISION Q
 DOUBLE PRECISION u, roh
 DOUBLE PRECISION findLowestEpsilon
 INTEGER i, j
 DOUBLE PRECISION previousResults(0:9999)
 LOGICAL previousResultKnowns(0:9999)
 DOUBLE PRECISION previousEpsils(0:9999)
 DOUBLE PRECISION links, rechts
 CALL clearQCache()
 epsil = 2.1D0
 roh0 = 0.1D0
 h = 0.1D0
 n = 0
 !DO i = 0, 99, 1
 ! WRITE (*,*) roh(i, roh0, h), u(i, h, epsil, roh0)
 !END DO
 !WRITE (*,*) ""
 !WRITE (*,*) ""
 rechts = 100000D0
 links = 0D0
 DO i = 0, 1000, 1
  epsil = findLowestEpsilon(links, rechts, h, roh0)
  IF (DABS(u(0, h, epsil, roh0)) .lt. 1D-17) THEN
    WRITE(*,*) "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!", epsil
  ELSE
    WRITE(*,*) "???", epsil, DABS(u(0, h, epsil, roh0))
  END IF
  links = epsil + 0.001D0
  IF (rechts .LT. links) THEN
    EXIT
  END IF
  WRITE(*,*) "===="
 END DO
 WRITE(*,*) epsil
 !DO j = 0, 99, 1
 ! WRITE (*,*) roh(j, roh0, h), u(j, h, epsil, roh0)
 !END DO
END
DOUBLE PRECISION FUNCTION findLowestEpsilon(alinks, arechts, h, roh0) RESULT (prevEpsil)
 IMPLICIT NONE
 INTEGER i
 DOUBLE PRECISION u
 DOUBLE PRECISION h
 DOUBLE PRECISION findEpsilon
 DOUBLE PRECISION roh0
 DOUBLE PRECISION, intent(in) :: alinks, arechts
 DOUBLE PRECISION :: links, rechts
 DOUBLE PRECISION :: epsil
 links = alinks
 rechts = arechts
 epsil = 0D0
 DO i = 0, 5000, 1
   prevEpsil = epsil
   epsil = findEpsilon(links, rechts, h, roh0)
   IF (DABS(u(0, h, epsil, roh0)) .ge. 1D-17) THEN ! wir nehmen an, es existiert gar keine passende Wellenfunktion mehr.
     EXIT
   END IF
   rechts = epsil - 0.0001D0
   IF (rechts .LT. links) THEN
     EXIT
   END IF
 END DO
 WRITE(*,*) "Ende von findLowestEpsilon, Wert=", prevEpsil, DABS(u(0, h, epsil, roh0))
END
DOUBLE PRECISION FUNCTION findEpsilon(alinks, arechts, h, roh0) RESULT (epsil)
 IMPLICIT NONE 
 DOUBLE PRECISION h
 DOUBLE PRECISION roh0
 DOUBLE PRECISION u
 DOUBLE PRECISION, intent(in) :: alinks, arechts
 DOUBLE PRECISION :: links, rechts
 DOUBLE PRECISION epsil
 INTEGER i
 links = alinks
 rechts = arechts
 DO i = 0, 10000, 1
  epsil = (rechts + links)/2D0
  IF (DABS(u(0, h, epsil, roh0)) .lt. 1D-17) THEN
   WRITE(*,*) "OK", epsil, DABS(u(0, h, epsil, roh0))
   exit
  ELSE IF (u(0, h, epsil, roh0) .gt. 0D0) THEN
   links = epsil
  ELSE IF (u(0, h, epsil, roh0) .lt. 0D0) THEN
   rechts = epsil
  END IF
  !WRITE (*,*) links, rechts
 END DO
 IF(i .GT. 10000) THEN
   WRITE(*,*) "(aufgegeben)", epsil, DABS(u(0, h, epsil, roh0))
 END IF
END

!w(n+1) = epsil - (roh(n+1) - roh0)
!Q(n+1) = (1D0 + h*h/12D0*w(n+1))*u(n+1)
!Q(n+1) = 12D0*u(n) - 10D0*Q(n) - Q(n-1)
!Q(n) = 12D0*u(n+1) - 10D0*Q(n+1) - Q(n+2)

DOUBLE PRECISION FUNCTION w(n, h, epsil, roh0) RESULT(result)
 IMPLICIT NONE
 INTEGER n
 DOUBLE PRECISION epsil, roh0, h
 DOUBLE PRECISION roh
 result = epsil - (roh(n, roh0, h) - roh0)
END

DOUBLE PRECISION FUNCTION roh(n, roh0, h) RESULT(result)
 IMPLICIT NONE
 INTEGER n
 DOUBLE PRECISION h, roh0
 result = roh0 + n*h
END

DOUBLE PRECISION RECURSIVE FUNCTION Qvonu(n, h, epsil, roh0) RESULT(result)
 IMPLICIT NONE
 INTEGER n
 DOUBLE PRECISION h, epsil, roh0
 DOUBLE PRECISION u, w  
 result = (1D0 + h*h/12D0*w(n, h, epsil, roh0))*u(n, h, epsil, roh0)
END
SUBROUTINE clearQCache()
 IMPLICIT NONE
 COMMON previousResults, previousResultKnowns, previousEpsils
 DOUBLE PRECISION previousResults(0:9999)
 LOGICAL previousResultKnowns(0:9999)
 DOUBLE PRECISION previousEpsils(0:9999)
 INTEGER i
 DO i=0,9999,1
   previousResultKnowns(i) = .FALSE.
   previousResults(i) = 42D0
   previousEpsils(i) = 0D0
 END DO
END
DOUBLE PRECISION RECURSIVE FUNCTION Q(n, h, epsil, roh0) RESULT(result)
 IMPLICIT NONE
 INTEGER n
 DOUBLE PRECISION h, epsil, roh0
 DOUBLE PRECISION u, Qvonu
 COMMON previousResults, previousResultKnowns, previousEpsils
 DOUBLE PRECISION previousResults(0:9999)
 LOGICAL previousResultKnowns(0:9999)
 DOUBLE PRECISION previousEpsils(0:9999)
 IF (previousResultKnowns(n) .AND. previousEpsils(n) .EQ. epsil) THEN
   result = previousResults(n)
 ELSE
   previousEpsils(n) = epsil
   IF (n .eq. 100) THEN
      result = Qvonu(n, h, epsil, roh0)
   ELSE IF (N .eq. 99) THEN
      result = Qvonu(n, h, epsil, roh0)
   ELSE 
      result = 12D0*u(n+1, h, epsil, roh0) - 10D0*Q(n+1, h, epsil, roh0) - Q(n+2, h, epsil, roh0)
   END IF
   previousResults(n) = result
   previousResultKnowns(n) = .TRUE.
 END IF
END
DOUBLE PRECISION RECURSIVE FUNCTION u(n, h, epsil, roh0) RESULT(result)
 IMPLICIT NONE
 INTEGER n
 DOUBLE PRECISION h, epsil, roh0
 DOUBLE PRECISION Q, w
 IF (n .eq. 100) THEN
  result = 0D0
 ELSE IF (N .eq. 99) THEN
  result = 1D-10
 ELSE 
  result = Q(n, h, epsil, roh0)/(1D0 + h*h/12D0*w(n, h, epsil, roh0))
 END IF
END

