MODULE globals
 DOUBLE PRECISION, PARAMETER :: dh = 3d0 !Schrittweite
 INTEGER, PARAMETER :: runs = 1000000
 INTEGER, PARAMETER :: warmups = 20000
 INTEGER, PARAMETER :: D = 100
 !DOUBLE PRECISION, PARAMETER :: dT = 1D0
END MODULE globals
PROGRAM berechneCV
 USE globals
 IMPLICIT NONE
 INTEGER iseed
 iseed = -int(time())
 CALL printValues(iseed, 0.05D0, 0.15D0, 0.01D0)
 CALL printValues(iseed, 0.1D0, 10D0, 0.1D0)
 CALL printValues(iseed, 9.9D0, 10.4D0, 0.1D0)
 !CALL printValues(iseed, 3.0D0, 6D0, 1D0)
 !CALL printValues(iseed, 6.0D0, 12D0, 2D0)
 !CALL printValues(iseed, 0.1D0, 12D0, 2D0)
END
SUBROUTINE printValues(iseed, T1, T2, dT)
 IMPLICIT NONE
 INTEGER, intent(inout) :: iseed
 DOUBLE PRECISION, intent(in) :: T1
 DOUBLE PRECISION, intent(in) :: T2
 DOUBLE PRECISION, intent(in) :: dT
 DOUBLE PRECISION approxMontecarlo2
 DOUBLE PRECISION T
 DOUBLE PRECISION beta
 DOUBLE PRECISION Cv
 INTEGER Ti
 DOUBLE PRECISION Es(0:100)
 INTEGER count1
 count1 = (T2 - T1)/dT
 DO Ti = 0, count1 - 1, 1
   T = T1 + Ti*dT
   beta = 1D0/T
   Es(Ti) = approxMontecarlo2(iseed, beta)
   Write(6,*) T,Es(Ti)
   IF (Ti > 0) THEN
     cV = (Es(Ti) - Es(Ti - 1))/dT
     !cV = (- Es(Ti + 2) + 8D0*Es(Ti + 1) - 8D0*Es(Ti - 1) + Es(Ti - 2))/(12D0*dT)
     WRITE (99,*) T, cV,Es(Ti)
   END IF
 END DO
END

DOUBLE PRECISION FUNCTION o1(x) RESULT(result)
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 DOUBLE PRECISION H
 result = H(x)**2
END

DOUBLE PRECISION FUNCTION o2(x) RESULT(result)
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 DOUBLE PRECISION H
 result = H(x)
END

DOUBLE PRECISION FUNCTION H(x) RESULT(result)
 USE globals
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 INTEGER I, d2
 d2 = D/2
 result = 0D0
 DO I = 0, d2 - 1
  result = result + ((x(I) - x(MOD(I - 1 + d2, d2)))**2)/2D0
 END DO
 DO I = d2, D - 1
  result = result + x(I)*x(I)/2D0
 END DO
END

DOUBLE PRECISION FUNCTION P(x, beta) RESULT(result)
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 DOUBLE PRECISION H
 DOUBLE PRECISION beta
 result = DEXP(-beta*H(x))
END

DOUBLE PRECISION FUNCTION approxMontecarlo2(iseed, beta) RESULT(h2_quer)
 USE globals
 IMPLICIT NONE
 !DOUBLE PRECISION h1_quer
 DOUBLE PRECISION h2_quer
 DOUBLE PRECISION ran2
 INTEGER iseed
 INTEGER o_count
 DOUBLE PRECISION r
 DOUBLE PRECISION beta
 INTEGER I, j,  k
 DOUBLE PRECISION P
 DOUBLE PRECISION o1
 DOUBLE PRECISION o2
 DOUBLE PRECISION x(0:9999), x_neu(0:9999)
 integer accepted
 accepted = 0
 x = 0D0 !Alle Elemente auf 0
 !h1_quer = 0d0
 h2_quer = 0d0
 o_count = 0
 DO j = 0, runs
  I = ran2(iseed)*D
  !DO I = 0, D - 1 
  IF (.TRUE.) THEN
   DO k = 0,D - 1
     x_neu(k) = x(k)
   END DO
   x_neu(I) = x(I) + (ran2(iseed) - 0.5D0)*(dh+0.3d0/beta)
   r = P(x_neu, beta)/P(x, beta)
   IF (ran2(iseed) .LE. dmin1(1D0, r)) THEN
    accepted=accepted+1
    x(I) = x_neu(I)
   END IF
   IF (j .GE. warmups) THEN
    !h1_quer = h1_quer + o1(x)
    h2_quer = h2_quer + o2(x)
    o_count = o_count + 1
   END IF
  END IF
 END DO
 write(6,*) accepted
 !h1_quer = h1_quer/o_count
 h2_quer = h2_quer/o_count
 !variance = h1_quer - h2_quer**2
END

