MODULE globals
 DOUBLE PRECISION, PARAMETER :: dh = 1D0/DSQRT(2D0)/16 !Schrittweite
 INTEGER, PARAMETER :: runs = 10000000
 INTEGER, PARAMETER :: warmups = 100000
 INTEGER, PARAMETER :: D = 100
 DOUBLE PRECISION, PARAMETER :: dT = 0.1D0
END MODULE globals
PROGRAM berechneCV
 USE globals
 IMPLICIT NONE
 DOUBLE PRECISION beta
 INTEGER iseed
 DOUBLE PRECISION cV
 DOUBLE PRECISION approxMontecarloVariance
 DOUBLE PRECISION T
 CHARACTER(len=32) :: arg
 INTEGER Ti
 INTEGER i
 iseed = -int(time())
 CALL getarg(1, arg)
 Ti = 0
 read(arg, '(i10)' ) Ti
 !DO Ti = 1, 100, 1
   T = 0.1D0 + Ti*dT
   beta = 1D0/T
   cV = beta**2*(approxMontecarloVariance(iseed, beta))
   WRITE (6,*) T, cV
   FLUSH(6)
 !END DO
END

DOUBLE PRECISION FUNCTION o1(x) RESULT(result)
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 DOUBLE PRECISION H
 result = H(x)**2
END

DOUBLE PRECISION FUNCTION o2(x) RESULT(result)
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 DOUBLE PRECISION H
 result = H(x)
END

DOUBLE PRECISION FUNCTION H(x) RESULT(result)
 USE globals
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 INTEGER I, d2
 d2 = D/2
 result = 0D0
 DO I = 0, d2 - 1
  result = result + ((x(I) - x(MOD(I - 1 + d2, d2)))**2)/2D0
 END DO
 DO I = d2, D - 1
  result = result + x(I)*x(I)/2D0
 END DO
END

DOUBLE PRECISION FUNCTION P(x, beta) RESULT(result)
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999)
 DOUBLE PRECISION H
 DOUBLE PRECISION beta
 result = DEXP(-beta*H(x))
END

DOUBLE PRECISION FUNCTION approxMontecarloVariance(iseed, beta) RESULT(variance)
 USE globals
 IMPLICIT NONE
 DOUBLE PRECISION h1_quer
 DOUBLE PRECISION h2_quer
 DOUBLE PRECISION ran2
 INTEGER iseed
 INTEGER o_count
 DOUBLE PRECISION r
 DOUBLE PRECISION beta
 INTEGER I, j,  k
 DOUBLE PRECISION P
 DOUBLE PRECISION o1
 DOUBLE PRECISION o2
 DOUBLE PRECISION x(0:9999), x_neu(0:9999)
 x = 0D0 !Alle Elemente auf 0
 h1_quer = 0d0
 h2_quer = 0d0
 o_count = 0
 DO j = 0, runs
  I = ran2(iseed)*D
  !DO I = 0, D - 1 
  IF (.TRUE.) THEN
   DO k = 0,D - 1
     x_neu(k) = x(k)
   END DO
   x_neu(I) = x(I) + (ran2(iseed) - 0.5D0)*dh
   r = P(x_neu, beta)/P(x, beta)
   IF (ran2(iseed) .LE. dmin1(1D0, r)) THEN
    x(I) = x_neu(I)
   END IF
   IF (j .GE. warmups) THEN
    h1_quer = h1_quer + o1(x)
    h2_quer = h2_quer + o2(x)
    o_count = o_count + 1
   END IF
  END IF
 END DO
 h1_quer = h1_quer/o_count
 h2_quer = h2_quer/o_count
 variance = h1_quer - h2_quer**2
END

