/**********************************************************************/
/* rand1.c                                                            */
/*                                                                    */
/* Aufruf:                                                            */
/* rand1 Anzahl                                                       */
/*                                                                    */
/* Berechnet gleichverteilte Zufallszahlen und stellt sie             */
/* grafisch dar.                                                      */
/* Anzahl = (int),   Anzahl der Datenpunkte (Zufallszahlen[paare])    */
/* Beispiel: rand1 50000                                              */
/* Die Grafik wird durch Anklicken geloescht                          */
/*                                                                    */
/* Es werden auf RAND_MAX normierte Zufallszahlen und die             */
/* Bibliotheksfunktion rand() verwendet                               */
/* Fuer die Grafiken wird die GNU plotlib mit integer-Funktionen      */
/* verwendet                                                          */
/*                                                                    */
/* Compilieren: gcc rand1.c -o rand1 -lplot                           */
/*                                                                    */
/**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <plot.h>
#include <math.h>

void draw_randomdots (int n)
{int handle,ix,iy,i;
 handle=pl_newpl("X",stdin,stdout,stderr);
 pl_selectpl(handle);
 pl_openpl();
 pl_space(0,0,RAND_MAX,RAND_MAX);
 for(i=0;i<n;++i)
 {ix=rand();
  iy=rand();
  pl_point(ix,iy);
 }
 pl_closepl();
}
void usage()
{printf("\nAufruf:\n"
 "rand1 Anzahl\n"
 "Berechnet gleichverteilte Zufallszahlen und stellt sie grafisch dar.\n"
 "Anzahl = (int),   Anzahl der Datenpunkte (Zufallszahlen[paare])\n"
 "Beispiel: rand1 50000\n"
 "Die Grafik wird durch Anklicken geloescht.\n\n");
 exit(-1);
}
int main (int argc, char** argv)
{int n;
 if(argc!=2) usage();
 draw_randomdots(atoi(argv[1]));
}





