PROGRAM spline
  IMPLICIT NONE
  DOUBLE PRECISION X1
  DOUBLE PRECISION s
  DOUBLE PRECISION Fs(0:100)
  DOUBLE PRECISION As(0:100)
  DOUBLE PRECISION hs(0:99)
  DOUBLE PRECISION mus(0:100)
  DOUBLE PRECISION lambdas(0:100)
  DOUBLE PRECISION ds(0:100)
  DOUBLE PRECISION Ms(0:100)
  DOUBLE PRECISION Cs(0:99)
  DOUBLE PRECISION Dds(0:99)
  DOUBLE PRECISION xx
  COMMON hs, N, mus, As, lambdas, Fs, ds
 
  DOUBLE PRECISION divdiff3
  INTEGER I, N, XI, J
  CALL ReadPoints()
  DO I=1,N,1
    mus(I)=hs(I-1)/(hs(I-1) + hs(I))
    lambdas(I)=1D0 - mus(I)
  END DO
  DO I=1,N-1,1
    ds(I)=6*divdiff3(As(I-1),As(I),As(I+1),Fs(I-1),Fs(I),Fs(I+1))
  END DO
  !ds(0)=6*divdiff2(As(0),As(1))
  !ds(N)=
  DO J=1,N-1,1
    Ms(J) = xx(J)
  END DO
  Ms(0) = 0D0
  Ms(N) = 0D0
  DO I=0,N-1,1
    Cs(I)=(Fs(I+1) + Fs(I))/2D0 - hs(I)**2/12D0*(Ms(I+1) + Ms(I))
    Dds(I)=(Fs(I+1) - Fs(I))/hs(I) - hs(I)/6D0*(Ms(I+1) - Ms(I))
  END DO
  I = 0
  DO XI=0,1500
    X1 = XI/100D0
    DO WHILE (I .LT. N - 1 .AND. X1 .GT. As(I + 1))
      I = I + 1
    END DO
    s = Cs(I) + Dds(I)*(X1-(As(I) + As(I + 1))/2D0)
    s = s + Ms(I+1)*(X1-As(I))**3/(6D0*hs(I))
    s = s - Ms(I)*(X1-As(I+1))**3/(6D0*hs(I))
    write(*,*) X1, s
  END DO
END
SUBROUTINE ReadPoints
  COMMON hs, N, mus, As, lambdas, Fs, ds
  DOUBLE PRECISION Fs(0:100)
  DOUBLE PRECISION As(0:100)
  DOUBLE PRECISION hs(0:99)
  DOUBLE PRECISION mus(0:100)
  DOUBLE PRECISION lambdas(0:100)
  DOUBLE PRECISION ds(0:100)
  DOUBLE PRECISION X1
  DOUBLE PRECISION Y
  INTEGER N
  OPEN(11, FILE="Punkte.dat", STATUS="OLD") ! muss sortiert sein
  N = 0
  DO I=0,100,1
    READ(11,*,END=100) X1, Y
    !WRITE(*,*) X1, Y
    As(I) = X1
    Fs(I) = Y
    IF (I > 0) THEN
      hs(I-1) = As(I) - As(I-1)
    END IF
    N = N + 1
  END DO
100   CLOSE(11)

END
RECURSIVE DOUBLE PRECISION FUNCTION divdiff3(a,b,c,X,Y,Z) RESULT (RESULT)
  IMPLICIT NONE
  DOUBLE PRECISION A
  DOUBLE PRECISION B
  DOUBLE PRECISION C
  DOUBLE PRECISION X
  DOUBLE PRECISION Y
  DOUBLE PRECISION Z
  DOUBLE PRECISION divdiff2
  RESULT = (divdiff2(b,c,Y,Z) - divdiff2(a,b,X,Y))/(c - a)
END
RECURSIVE DOUBLE PRECISION FUNCTION divdiff2(a,b,X,Y) RESULT (RESULT)
  IMPLICIT NONE
  DOUBLE PRECISION A
  DOUBLE PRECISION B
  DOUBLE PRECISION X
  DOUBLE PRECISION Y
  RESULT = (Y - X)/(b - a)
END

RECURSIVE DOUBLE PRECISION FUNCTION d(I) RESULT (RESULT)
 IMPLICIT NONE
 INTEGER I
  COMMON hs, N, mus, As, lambdas, Fs, ds
  DOUBLE PRECISION Fs(0:100)
  DOUBLE PRECISION As(0:100)
  DOUBLE PRECISION hs(0:99)
  DOUBLE PRECISION mus(0:100)
  DOUBLE PRECISION lambdas(0:100)
  DOUBLE PRECISION ds(0:100)
  INTEGER N
 DOUBLE PRECISION kappa
 IF (I .eq. 1) THEN
   RESULT = 2D0
 ELSE
   RESULT = 2D0 - kappa(I)*lambdas(I-1)
 END IF
END
RECURSIVE DOUBLE PRECISION FUNCTION y(I) RESULT (RESULT)
 IMPLICIT NONE
 INTEGER I
  COMMON hs, N, mus, As, lambdas, Fs, ds
  DOUBLE PRECISION Fs(0:100)
  DOUBLE PRECISION As(0:100)
  DOUBLE PRECISION hs(0:99)
  DOUBLE PRECISION mus(0:100)
  DOUBLE PRECISION lambdas(0:100)
  DOUBLE PRECISION ds(0:100)
  INTEGER N
 DOUBLE PRECISION kappa
 IF (I .eq. 1) THEN
   RESULT = ds(1)
 ELSE
   RESULT = ds(I) - kappa(I)*y(I-1)
 END IF
END
RECURSIVE DOUBLE PRECISION FUNCTION kappa(I) RESULT (RESULT)
 IMPLICIT NONE
 INTEGER I
 DOUBLE PRECISION d
  COMMON hs, N, mus, As, lambdas, Fs, ds
  DOUBLE PRECISION Fs(0:100)
  DOUBLE PRECISION As(0:100)
  DOUBLE PRECISION hs(0:99)
  DOUBLE PRECISION mus(0:100)
  DOUBLE PRECISION lambdas(0:100)
  DOUBLE PRECISION ds(0:100)
  INTEGER N
 RESULT = mus(I)/d(I-1)
END
RECURSIVE DOUBLE PRECISION FUNCTION xx(I) RESULT (RESULT)
 IMPLICIT NONE
 INTEGER I
 DOUBLE PRECISION d
 DOUBLE PRECISION y
 RESULT = y(I)/d(I)
END

